 //+--------------------------------------------------------------------------+
 //|                                                                          |
 //|                                StarGate                                  |
 //|                              Version 2.00                                |
 //|                                                                          |
 //|   How to ceate a mini demoscene using Bass.dll and OpenGL altogether.    |
 //|                                                                          |
 //|   The free trial versions of WinLIFT.dll and GDImage are used to skin    |
 //|   the project and allow the use of advanced WGL extensions.              |
 //|                                                                          |
 //+--------------------------------------------------------------------------+
 //|                                                                          |
 //|                         Author Patrice TERRIER                           |
 //|                           copyright (c) 2013                             |
 //|                                                                          |
 //|                        pterrier@zapsolution.com                          |
 //|                                                                          |
 //|                          www.zapsolution.com                             |
 //|                                                                          |
 //+--------------------------------------------------------------------------+
 //|                  Project started on : 09-19-2010 (MM-DD-YYYY)            |
 //|                        Last revised : 12-10-2013 (MM-DD-YYYY)            |
 //+--------------------------------------------------------------------------+

#include "stdafx.h"
#include <windows.h>
#include <Commctrl.h>
#include <vector>
#include <string>
#include <time.h>
#include <gl/GL.h>
#include <Uxtheme.h>

#pragma comment(lib, "..\\GDImage64.lib")
//#pragma comment(lib, "..\\GDImage32.lib")
#include "GDImage.h"

#pragma comment(lib, "..\\WinLIFT64.lib")
//#pragma comment(lib, "D:\\VS2010\\WinLIFT32.lib")
#include "WinLIFT.h"

#include "BassAudio.h"

// Enable tooltip support
#pragma comment(linker,"\"/manifestdependency:type='win32' \
name='Microsoft.Windows.Common-Controls' version='6.0.0.0' \
processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")


#define UBOUND(T) (T.size())
#define long_proc typedef long (__stdcall *zProc)

struct TParticle {
    float X;
    float Y;
    float Z;
    float XSpeed;
    float YSpeed;
    float ZSpeed;
};

struct THISOBJECT {
    float radius;
    float barsize;
    float xoff;
    float yoff;
    float zoff;
    float xrot;
    float yrot;
    float xcpy;
    float ycpy;
    long  move;
    long  xdown;
    long  ydown;
    long  mouseDown;
    long  listIndex;
};

struct TVertex {
    float X;
    float Y;
    float Z;
};

#define ClientW         1000
#define ClientH         532

const DWORD TUNNEL_START  =   2800;
const DWORD TUNNEL_END    =  29500;
const DWORD MONOLITH_SHOW =  31500;

#define IDC_GLCTRL     -100
#define IDC_STATIC     -101
#define IDC_LABEL      -102
#define IDC_ZOOM       -103
#define IDC_CLOCK      -104
#define IDC_RESET      -105
#define IDC_STATIC_IMG -106
#define IDC_TIMER      -107

#define TEXTURE_SPEED   0.022f
#define ZOOM_DEFAULT    55

#define GL_MULTISAMPLE_ARB 0x809D

#define TIMER_DELAY     1 // Animation speed.

HWND gh_Main, gh_GLwnd;
WNDPROC gh_GLproc;
float gr_Percent;

long gn_SoundExplode;
wstring gs_Resource;

vector <ZGLTEXTUREX> g_mt;
vector <TParticle> ga_Particle;
vector <wstring> g_Spinner;
THISOBJECT gl_Obj;
BYTE g_R[34] = {0}, g_G[34] = {0}, g_B[34] = {0}, g_A[34] = {0};
long g_nUseSpinner;

// Main window minimum horizontal track size
long MinTrackSizeW (IN long SizeX) { // dllexport
    static long WasSizeX;
    if (SizeX) { WasSizeX = SizeX; }
    return WasSizeX;
}

// Main window minimum vertical track size
long MinTrackSizeH (IN long SizeY) { // dllexport
    static long WasSizeY;
    if (SizeY) { WasSizeY = SizeY; }
    return WasSizeY;
}

void gl_ColorInit() {
    g_R[33] = 32;  g_G[33] = 32;  g_B[33] = 32;  g_A[33] = 255;
    g_R[32] = 0;   g_G[32] = 44;  g_B[32] = 233; g_A[32] = 255;
    g_R[31] = 0;   g_G[31] = 67;  g_B[31] = 210; g_A[31] = 255;
    g_R[30] = 0;   g_G[30] = 89;  g_B[30] = 187; g_A[30] = 255;
    g_R[29] = 0;   g_G[29] = 112; g_B[29] = 164; g_A[29] = 255;
    g_R[28] = 0;   g_G[28] = 135; g_B[28] = 142; g_A[28] = 255;
    g_R[27] = 0;   g_G[27] = 159; g_B[27] = 117; g_A[27] = 255;
    g_R[26] = 0;   g_G[26] = 183; g_B[26] = 88;  g_A[26] = 255;
    g_R[25] = 0;   g_G[25] = 207; g_B[25] = 58;  g_A[25] = 255;
    g_R[24] = 0;   g_G[24] = 231; g_B[24] = 29;  g_A[24] = 255;
    g_R[23] = 26;  g_G[23] = 234; g_B[23] = 26;  g_A[23] = 255;
    g_R[22] = 52;  g_G[22] = 237; g_B[22] = 23;  g_A[22] = 255;
    g_R[21] = 79;  g_G[21] = 240; g_B[21] = 20;  g_A[21] = 255;
    g_R[20] = 105; g_G[20] = 243; g_B[20] = 17;  g_A[20] = 255;
    g_R[19] = 126; g_G[19] = 245; g_B[19] = 14;  g_A[19] = 255;
    g_R[18] = 147; g_G[18] = 248; g_B[18] = 11;  g_A[18] = 255;
    g_R[17] = 168; g_G[17] = 250; g_B[17] = 8;   g_A[17] = 255;
    g_R[16] = 189; g_G[16] = 253; g_B[16] = 5;   g_A[16] = 255;
    g_R[15] = 210; g_G[15] = 255; g_B[15] = 2;   g_A[15] = 255;
    g_R[14] = 233; g_G[14] = 255; g_B[14] = 0;   g_A[14] = 255;
    g_R[13] = 255; g_G[13] = 255; g_B[13] = 0;   g_A[13] = 255;
    g_R[12] = 255; g_G[12] = 251; g_B[12] = 0;   g_A[12] = 255;
    g_R[11] = 255; g_G[11] = 235; g_B[11] = 0;   g_A[11] = 255;
    g_R[10] = 255; g_G[10] = 215; g_B[10] = 0;   g_A[10] = 255;
    g_R[9]  = 255;  g_G[9] = 196;  g_B[9] = 0;    g_A[9] = 255;
    g_R[8]  = 255;  g_G[8] = 176;  g_B[8] = 0;    g_A[8] = 255;
    g_R[7]  = 255;  g_G[7] = 156;  g_B[7] = 0;    g_A[7] = 255;
    g_R[6]  = 253;  g_G[6] = 137;  g_B[6] = 0;    g_A[6] = 255;
    g_R[5]  = 255;  g_G[5] = 117;  g_B[5] = 0;    g_A[5] = 255;
    g_R[4]  = 255;  g_G[4] = 97;   g_B[4] = 0;    g_A[4] = 255;
    g_R[3]  = 255;  g_G[3] = 78;   g_B[3] = 0;    g_A[3] = 255;
    g_R[2]  = 255;  g_G[2] = 58;   g_B[2] = 0;    g_A[2] = 255;
    g_R[1]  = 255;  g_G[1] = 0;    g_B[1] = 0;    g_A[1] = 255;
} 

void SetLevelColr(IN long nLevel) {
    BYTE cbR = 0, cbG = 0, cbB = 0;
    nLevel += 1; if (nLevel > 33) { nLevel = 33; }
    if (nLevel > 0) {
       cbR = g_R[nLevel];
       cbG = g_G[nLevel];
       cbB = g_B[nLevel];
    }
    glColor4ub(cbR , cbG , cbB, 64);
}

void InitObject() {
    gl_Obj.xoff = -0.0f;  // Initial x location.
    gl_Obj.yoff = -0.0f;  // Initial y location.
    gl_Obj.zoff = -3.0f;  // Initial zoom factor.

    gl_Obj.xrot = 5.0f;
    gl_Obj.yrot = 0.0f;
    gl_Obj.radius = 0.0f;

    // User variables
    ga_Particle.resize(41);
}

void gl_Initialize() {

    InitObject();

    glClearColor(0.0f, 0.0f, 0.0f, 1.0f); // Black background.
    glShadeModel(GL_SMOOTH);              // Enables Smooth Color Shading.
    glClearDepth(1);                      // Depth Buffer Setup.

    glEnable(GL_DEPTH_TEST);              // Enable Depth Buffer.
    glDepthFunc(GL_LESS);                 // The type of depth test to do.

    glBlendFunc(GL_SRC_ALPHA, GL_ONE);
    glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);

    float LightDiffuse[4] = { 0.5f, 0.5f, 1.0f, 1.0f };
    float LightAmbient[4] = { 0.3f, 0.3f, 0.3f, 1.0f };
    float LightPosition[4] = { -2.0f, 2.0f, -15.0f, 1.0f};

    glLightfv(GL_LIGHT0, GL_DIFFUSE, LightDiffuse);   // Setup Diffuse light
    glLightfv(GL_LIGHT0, GL_AMBIENT, LightDiffuse) ;  // Setup Ambient light
    glLightfv(GL_LIGHT0, GL_POSITION, LightPosition); // Position Light

    glMaterialfv(GL_FRONT, GL_SPECULAR, LightDiffuse);
    float Emission[1] = {0.05f}; glMaterialfv(GL_FRONT, GL_EMISSION, Emission);
    float Shininess[1] = {5.0f}; glMaterialfv(GL_FRONT, GL_SHININESS, Shininess);

    glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);

    //Load textures
    glEnable(GL_TEXTURE_2D);                          // Enable Texture Mapping
    g_mt.resize(9);                                   // We use 9 textures
    wstring ws;
    ws = gs_Resource; ws.append(L"tunnel.png");     wcscpy_s(g_mt[0].FullName, (WCHAR*) ws.c_str()); g_mt[0].ID = 1; g_mt[0].Square = 0;
    ws = gs_Resource; ws.append(L"earth.png");      wcscpy_s(g_mt[1].FullName, (WCHAR*) ws.c_str()); g_mt[1].ID = 2; g_mt[1].Square = 0;
    ws = gs_Resource; ws.append(L"Particle.png");   wcscpy_s(g_mt[2].FullName, (WCHAR*) ws.c_str()); g_mt[2].ID = 3; g_mt[2].Square = 0;
    ws = gs_Resource; ws.append(L"starburst.jpg");  wcscpy_s(g_mt[3].FullName, (WCHAR*) ws.c_str()); g_mt[3].ID = 4; g_mt[3].Square = 0;
    ws = gs_Resource; ws.append(L"monolith.png");   wcscpy_s(g_mt[4].FullName, (WCHAR*) ws.c_str()); g_mt[4].ID = 5; g_mt[4].Square = 0;
    ws = gs_Resource; ws.append(L"monolith0.png");  wcscpy_s(g_mt[5].FullName, (WCHAR*) ws.c_str()); g_mt[5].ID = 6; g_mt[5].Square = 0;
    ws = gs_Resource; ws.append(L"stargate.jpg");   wcscpy_s(g_mt[6].FullName, (WCHAR*) ws.c_str()); g_mt[6].ID = 7; g_mt[6].Square = 0;
    ws = gs_Resource; ws.append(L"hub.png");        wcscpy_s(g_mt[7].FullName, (WCHAR*) ws.c_str()); g_mt[7].ID = 8; g_mt[7].Square = 1;
    ws = gs_Resource; ws.append(L"Side.png");       wcscpy_s(g_mt[8].FullName, (WCHAR*) ws.c_str()); g_mt[8].ID = 9; g_mt[8].Square = 0;

    ZI_MakeMultipleTexture(&g_mt[0], (long) UBOUND(g_mt));

    gl_ColorInit();

    // Randomize TIMER
    srand((unsigned) time(NULL));

    // Initialise all particles
    long I = 0, J = 0;
    for (I = 1; I < 41; I++) {
         ga_Particle[I].XSpeed = (rand() % 99) / 2000.0f - 0.025f; // Random speed
         ga_Particle[I].YSpeed = (rand() % 99) / 2000.0f - 0.025f;
         ga_Particle[I].ZSpeed = (rand() % 99) / 3000.0f + 0.2f;
         ga_Particle[I].X = (rand() % 99) / 1000.0f;               // Give it a random position based on the speed.
         ga_Particle[I].Y = (rand() % 99) / 1000.0f;
         ga_Particle[I].Z = (rand() % 99) / 1000.0f;
    }

    // shuffle particles around a bit
    for (J = 1; J < 501; J++) {
        for (I = 1; I < 41; I++) {
            ga_Particle[I].X += ga_Particle[I].XSpeed;
            ga_Particle[I].Y += ga_Particle[I].YSpeed;
            ga_Particle[I].Z += ga_Particle[I].ZSpeed;
            if (sqrtf(ga_Particle[I].X * ga_Particle[I].X + ga_Particle[I].Y * ga_Particle[I].Y + ga_Particle[I].Z * ga_Particle[I].Z) > 16) {
               ga_Particle[I].X = 0;
               ga_Particle[I].Y = 0;
               ga_Particle[I].Z = 0;
            }
        }
    }
}

void gl_DestroyTexture() {
    long K, OkDelete = 0;
    long mtCount = (long) UBOUND(g_mt);
    if (mtCount) {
       long* Texture = new long[mtCount]; memset(Texture, 0, mtCount);
       for (K = 0; K < mtCount; K++) {
           Texture[K] = g_mt[K].Texture; if (Texture[K]) { OkDelete = -1; }
       }
       if (OkDelete) { glDeleteTextures(mtCount, (GLuint*) Texture[0]); }
       delete [] Texture;
    }
}

void DrawMonolith (IN long nValue, IN float Pulse, IN float MonolithAngle, IN long nItem) {

    float x = 0.24f, y = 0.74f, z = 0.03f, n = 0;

    float cPulse = 5 * Pulse;
    Pulse = abs(Pulse / 32.0f);

    glEnable(GL_CULL_FACE);

    glColor3f(1.0f, 1.0f, 1.0f);

    glDisable(GL_BLEND);
    glEnable(GL_LIGHT0);
    glEnable(GL_LIGHTING);
    glEnable(GL_COLOR_MATERIAL);

    // BackFace
    glBindTexture(GL_TEXTURE_2D, g_mt[4].Texture);
    glBegin(GL_QUADS);
       glTexCoord2f(1.0f, 0.0f); glVertex3f(-x,-y,-z); // Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0f, 1.0f); glVertex3f(-x, y,-z); // Top Right Of The Texture And Quad
       glTexCoord2f(0.0f, 1.0f); glVertex3f( x, y,-z); // Top Left Of The Texture And Quad
       glTexCoord2f(0.0f, 0.0f); glVertex3f( x,-y,-z); // Bottom Left Of The Texture And Quad
    glEnd();
    if (nItem == 1) {
       glColor3f(0.0f, 0.0f, cPulse); }
    else if (nItem == 2) {
       glColor3f(cPulse, cPulse, cPulse); }
    else {
       glColor3f(cPulse, 0.0f, 0.0f);
    }
    // TopFace
    glBegin(GL_QUADS);
       glTexCoord2f(0.0f, 1.0f); glVertex3f(-x, y,-z); // Top Left Of The Texture And Quad
       glTexCoord2f(0.0f, 0.0f); glVertex3f(-x, y, z); // Bottom Left Of The Texture And Quad
       glTexCoord2f(1.0f, 0.0f); glVertex3f( x, y, z); // Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0f, 1.0f); glVertex3f( x, y,-z); // Top Right Of The Texture And Quad
    glEnd();
    // BottomFace
    glBegin(GL_QUADS);
       glTexCoord2f(1.0f, 1.0f); glVertex3f(-x,-y,-z); // Top Right Of The Texture And Quad
       glTexCoord2f(0.0f, 1.0f); glVertex3f( x,-y,-z); // Top Left Of The Texture And Quad
       glTexCoord2f(0.0f, 0.0f); glVertex3f( x,-y, z); // Bottom Left Of The Texture And Quad
       glTexCoord2f(1.0f, 0.0f); glVertex3f(-x,-y, z); // Bottom Right Of The Texture And Quad
    glEnd();
    glColor3f(1, 1, 1);
     glBindTexture(GL_TEXTURE_2D, g_mt[8].Texture);
    // RightFace
    glBegin(GL_QUADS);
       glTexCoord2f(1.0f, 0.0f); glVertex3f( x,-y,-z); // Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0f, 1.0f); glVertex3f( x, y,-z); // Top Right Of The Texture And Quad
       glTexCoord2f(0.0f, 1.0f); glVertex3f( x, y, z); // Top Left Of The Texture And Quad
       glTexCoord2f(0.0f, 0.0f); glVertex3f( x,-y, z); // Bottom Left Of The Texture And Quad
    glEnd();
    // LeftFace
    glBegin(GL_QUADS);
       glTexCoord2f(0.0f, 0.0f); glVertex3f(-x,-y,-z); // Bottom Left Of The Texture And Quad
       glTexCoord2f(1.0f, 0.0f); glVertex3f(-x,-y, z); // Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0f, 1.0f); glVertex3f(-x, y, z); // Top Right Of The Texture And Quad
       glTexCoord2f(0.0f, 1.0f); glVertex3f(-x, y,-z); // Top Left Of The Texture And Quad
    glEnd();
     glBindTexture(GL_TEXTURE_2D, g_mt[4].Texture);
    // FrontFace
    glBegin(GL_QUADS);
       glTexCoord2f(0.0f, 0.0f); glVertex3f(-x,-y, z); // Bottom Left Of The Texture And Quad
       glTexCoord2f(1.0f, 0.0f); glVertex3f( x,-y, z); // Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0f, 1.0f); glVertex3f( x, y, z); // Top Right Of The Texture And Quad
       glTexCoord2f(0.0f, 1.0f); glVertex3f(-x, y, z); // Top Left Of The Texture And Quad
    glEnd();

    glEnable(GL_BLEND);

    // Display HAL
    if (nItem == 1) {
       glColor3f(1.0f - cPulse*0.3f, 1.0f - cPulse*0.3f, 1.0f); }
    else if (nItem == 2) {
       glColor3f(1.0f, 1.0f, 1.0f); }
    else {
       glColor3f(1.0f, 1.0f - cPulse*0.3f, 1.0f - cPulse*0.3f);
    }
    glBindTexture(GL_TEXTURE_2D, g_mt[7].Texture);
    x = 0.12f; y = 0.12f; z = 0.031f;
    glPushMatrix();
       glTranslatef(0.0f, -0.55f, 0.0f);
       glRotatef(MonolithAngle, 0.0f, 0.0f, 1.0f);
       glBegin(GL_QUADS);
          glTexCoord2f(0.0f, 0.0f); glVertex3f(-x,-y, z); // Bottom Left Of The Texture And Quad
          glTexCoord2f(1.0f, 0.0f); glVertex3f( x,-y, z); // Bottom Right Of The Texture And Quad
          glTexCoord2f(1.0f, 1.0f); glVertex3f( x, y, z); // Top Right Of The Texture And Quad
          glTexCoord2f(0.0f, 1.0f); glVertex3f(-x, y, z); // Top Left Of The Texture And Quad
       glEnd();
    glPopMatrix();
    x = 0.24f; y = 0.74f; z = 0.03f;
    // End HAL

    // Get audio data and set the color accordingly.
    if (ta.Channel) {
       SetLevelColr(nValue);
    }
    n = 0.02f;
    x += n + Pulse; y += n + Pulse; z += n + Pulse;
    glBindTexture(GL_TEXTURE_2D, g_mt[5].Texture);

    // BackFace
    glBegin(GL_QUADS);
       glTexCoord2f(1.0f, 0.0f); glVertex3f(-x,-y,-z); // Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0f, 1.0f); glVertex3f(-x, y,-z); // Top Right Of The Texture And Quad
       glTexCoord2f(0.0f, 1.0f); glVertex3f( x, y,-z); // Top Left Of The Texture And Quad
       glTexCoord2f(0.0f, 0.0f); glVertex3f( x,-y,-z); // Bottom Left Of The Texture And Quad
    glEnd();
    // TopFace
    glBegin(GL_QUADS);
       glTexCoord2f(0.0f, 1.0f); glVertex3f(-x, y,-z); // Top Left Of The Texture And Quad
       glTexCoord2f(0.0f, 0.0f); glVertex3f(-x, y, z); // Bottom Left Of The Texture And Quad
       glTexCoord2f(1.0f, 0.0f); glVertex3f( x, y, z); // Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0f, 1.0f); glVertex3f( x, y,-z); // Top Right Of The Texture And Quad
    glEnd();
    // BottomFace
    glBegin(GL_QUADS);
       glTexCoord2f(1.0f, 1.0f); glVertex3f(-x,-y,-z); // Top Right Of The Texture And Quad
       glTexCoord2f(0.0f, 1.0f); glVertex3f( x,-y,-z); // Top Left Of The Texture And Quad
       glTexCoord2f(0.0f, 0.0f); glVertex3f( x,-y, z); // Bottom Left Of The Texture And Quad
       glTexCoord2f(1.0f, 0.0f); glVertex3f(-x,-y, z); // Bottom Right Of The Texture And Quad
    glEnd();
    // RightFace
    glBegin(GL_QUADS);
       glTexCoord2f(1.0f, 0.0f); glVertex3f( x,-y,-z); // Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0f, 1.0f); glVertex3f( x, y,-z); // Top Right Of The Texture And Quad
       glTexCoord2f(0.0f, 1.0f); glVertex3f( x, y, z); // Top Left Of The Texture And Quad
       glTexCoord2f(0.0f, 0.0f); glVertex3f( x,-y, z); // Bottom Left Of The Texture And Quad
    glEnd();
    // LeftFace
    glBegin(GL_QUADS);
       glTexCoord2f(0.0f, 0.0f); glVertex3f(-x,-y,-z); // Bottom Left Of The Texture And Quad
       glTexCoord2f(1.0f, 0.0f); glVertex3f(-x,-y, z); // Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0f, 1.0f); glVertex3f(-x, y, z); // Top Right Of The Texture And Quad
       glTexCoord2f(0.0f, 1.0f); glVertex3f(-x, y,-z); // Top Left Of The Texture And Quad
    glEnd();
    // FrontFace
    glBegin(GL_QUADS);
       glTexCoord2f(0.0f, 0.0f); glVertex3f(-x,-y, z); // Bottom Left Of The Texture And Quad
       glTexCoord2f(1.0f, 0.0f); glVertex3f( x,-y, z); // Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0f, 1.0f); glVertex3f( x, y, z); // Top Right Of The Texture And Quad
       glTexCoord2f(0.0f, 1.0f); glVertex3f(-x, y, z); // Top Left Of The Texture And Quad
    glEnd();

    glDisable(GL_LIGHT0);
    glDisable(GL_LIGHTING);
    glDisable(GL_COLOR_MATERIAL);

    glDisable(GL_CULL_FACE);
}

void SetZoom(IN long zoom) {
    ZI_SetGLzoom(gh_GLwnd, zoom);
    ZI_ResizeGLWindow(gh_GLwnd);
}

// This is the place where to customize the scene.
void gl_DrawScene() {
    long nValue = 0, nLValue = 0, nRValue = 0, nTex = 0;
    long I = 0, J = 0, DemoTime = 0, ShowMonolith = 0, ZoomIs = 0, BackgroundIsFix = 0, nLevel = 0;
    float cPulse = 0, Pulse = 0;
    float Angle = 0, C = 0, R = 0, A1 = 0, A2 = 0, A3 = 0, A4 = 0;
    float ParticleX = 0, ParticleY = 0, ParticleZ = 0;
    DWORD LastTime = 0;
    wstring ws;

    static float LastC, MonolithAngle;
    static DWORD DemoStart, ElapsedTime, TimeZoomOut;

    TVertex Tunnels[14][33] = {0};

    if (ta.Channel) {

       nValue          = BASS_ChannelGetLevel(ta.Channel);
       ta.Lpeak        = SolvePeak(LOWORD(nValue), 128);
       ta.Rpeak        = SolvePeak(HIWORD(nValue), 128);
       ta.FFTdata      = BassChannelGetData();
       ta.FFTsize      = 256;
       ta.WIMdata      = BassChannelGetWimData(ta.Channel);

       nLValue = (ta.Lpeak / 700);
       nRValue = (ta.Rpeak / 768);
       nValue = max(nLValue, nRValue);
       Pulse = nValue / 14.0f;

    }


    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);    // Clear The Screen And The Depth Buffer
    glLoadIdentity();                                      // Reset The View

    if (DemoStart == 0) { DemoStart = GetTickCount(); }
    LastTime = ElapsedTime;
    ElapsedTime = GetTickCount() - DemoStart;      // Calculate Elapsed Time

    ElapsedTime = (LastTime + ElapsedTime) / 2;    // Average it out FOR smoother movement

    DemoTime = (long) (ElapsedTime - TUNNEL_START);

    if ((long) (MONOLITH_SHOW - ElapsedTime) < 0) {
        ShowMonolith = -1;

        if (ta.Channel == 0) {
            ws = gs_Resource; ws.append(L"monolith.xm");
            wcscpy_s(ta.AudioFile, (WCHAR*) ws.c_str());
            BassChannelPlay(gh_Main);
        }
    }

    // Save current zoom, then switch to a fixed zoom for background.
    ZoomIs = ZI_GetGLzoom(gh_GLwnd);
    SetZoom(45);

    glDisable(GL_DEPTH_TEST);
    glEnable(GL_BLEND);
    // Draw background
    if (ShowMonolith == 0) {
       cPulse = DemoTime / 400.0f;
       glColor3f(1 - cPulse / 36.0f, 1 - cPulse / 45.0f, 1 - cPulse / 48.0f); }
    else {
       cPulse = Pulse / 4.0f;
       glColor3f(1.0f - cPulse, 1.0f - cPulse, 1.0f);
    }
    glBindTexture(GL_TEXTURE_2D, g_mt[1].Texture);
    glBegin(GL_QUADS);
       glTexCoord2f(0.0f, 0.0f); glVertex3f(-80.0f,-40.0f,-80.0f + cPulse);  // Bottom Left Of The Texture And Quad
       glTexCoord2f(1.0f, 0.0f); glVertex3f( 80.0f,-40.0f,-80.0f + cPulse);  // Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0f, 1.0f); glVertex3f( 80.0f, 40.0f,-80.0f + cPulse);  // Top Right Of The Texture And Quad
       glTexCoord2f(0.0f, 1.0f); glVertex3f(-80.0f, 40.0f,-80.0f + cPulse);  // Top Left Of The Texture And Quad
    glEnd();

    if (ShowMonolith) {
       // Rotate the flare hover the background.
       glPushMatrix();
          SetLevelColr(nValue);
          glRotatef(MonolithAngle, 0.0f, 0.0f, 1.0f);
          glBindTexture(GL_TEXTURE_2D, g_mt[6].Texture); // Flare0.png
          glBegin(GL_QUADS);
             glTexCoord2f(0, 0); glVertex3f(-65.0f,-65.0f, -65.0f);
             glTexCoord2f(1, 0); glVertex3f( 65.0f,-65.0f, -65.0f);
             glTexCoord2f(1, 1); glVertex3f( 65.0f, 65.0f, -65.0f);
             glTexCoord2f(0, 1); glVertex3f(-65.0f, 65.0f, -65.0f);
          glEnd();
       glPopMatrix();
    }

    // Restore the previously saved zoom.
    SetZoom(ZoomIs);

    // Set the camera location based on user mousing.
    glTranslatef(gl_Obj.xoff, gl_Obj.yoff, gl_Obj.zoff);
    glRotatef(gl_Obj.xrot, 1.0f, 0.0f, 0.0f);
    glRotatef(gl_Obj.yrot, 0.0f, 1.0f, 0.0f);

    // Startgate entrance
    if (DemoTime < 2000) {
       C = DemoTime / 50.0f;
       glTranslatef(0.0f, 0.0f, 10.0f + C);
       glRotatef((float)DemoTime / 14.0f, 0.0f, 0.0f, 1.0f);
       glBindTexture(GL_TEXTURE_2D, g_mt[6].Texture);
       glBegin(GL_QUADS);
          glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0,-1.0, -10.0f); // Bottom Left Of The Texture And Quad
          glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0,-1.0, -10.0f); // Bottom Right Of The Texture And Quad
          glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0, 1.0, -10.0f); // Top Right Of The Texture And Quad
          glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0, 1.0, -10.0f); // Top Left Of The Texture And Quad
       glEnd();
       glTranslatef(0.0f, 0.0f, -(10.0f + C));
    }

    if (ShowMonolith == 0) {
        Angle = DemoTime / 14.0f;
        // Setup tunnel coordinates
        A1 = -2 * cos(Angle / 29.0f) - sin(Angle / 13.0f);
        A2 = -2 * sin(Angle / 33.0f) - cos(Angle / 17.0f);
        for (I = 0; I < 14; I++) {
            A3 = (float) 0.5235987756f * (float) I;
            for (J = 0; J < 32; J++) {
                A4 = Angle + 2.0f * (float) J;
                Tunnels[I][J].X = (4.2f - (float) J / 12.0f) * sin(A3) + 2.0f * cos(A4 / 29.0f) + sin(A4 / 13.0f) + A1;
                Tunnels[I][J].Y = (4.2f - (float) J / 12.0f) * cos(A3) + 2.0f * sin(A4 / 33.0f) + cos(A4 / 17.0f) + A2;
            }
        }

        // Draw the tunnel
        glEnable(GL_DEPTH_TEST);  // Hide the tunnel in the distance
        glBindTexture(GL_TEXTURE_2D, g_mt[0].Texture); // TunnelTex
        for (J = 0; J < 32; J++) {
            A1 = J / 32.0f + Angle * TEXTURE_SPEED;  // Precalculate texture v coords FOR speed
            A2 = (J + 1) / 32.0f + Angle * TEXTURE_SPEED;

            // Near the end of the tunnel, fade the effect away
            if (J > 24) {
                C = 1.0f - (J - 24.0f) / 10.0f; }
            else {
                C = 1.0f;
            }

            // Fade in tunnel
            if (DemoTime < 2000) { C *= DemoTime / 2000.0f; }

            glColor3f(C, C, C);

            glBegin(GL_QUADS);
                for (I = 0; I < 12; I++) {
                    glTexCoord2f((float)      I / 12.0f, A1); glVertex3f((float) Tunnels[I][J].X, (float) Tunnels[I][J].Y, (float) -J);
                    glTexCoord2f((float)(I + 1) / 12.0f, A1); glVertex3f((float) Tunnels[I + 1][J].X, (float) Tunnels[I + 1][J].Y, (float) -J);
                    glTexCoord2f((float)(I + 1) / 12.0f, A2); glVertex3f((float) Tunnels[I + 1][J + 1].X, (float) Tunnels[I + 1][J + 1].Y, (float) -J - 1.0f);
                    glTexCoord2f((float)      I / 12.0f, A2); glVertex3f((float) Tunnels[I][J+1].X, (float) Tunnels[I][J + 1].Y, (float) -J - 1.0f);
                }
            glEnd();
        }

        // At the end of the sequence, fade in the starburst
        if ((long) (TUNNEL_END - ElapsedTime) < 500) {

            if (gn_SoundExplode == 0) {
                gn_SoundExplode = -1;
                ws = gs_Resource; ws.append(L"explode.ogg");
                wcscpy_s(ta.AudioFile, (WCHAR*) ws.c_str());
                BassChannelPlay(gh_Main);

                // Setup the ZoomOut duration to show the monolith first time.
                TimeZoomOut = GetTickCount() + ZI_GetGLzoom(gh_GLwnd) * 100;
 
                // Update the GDImage g_mt[1].Texture, to replace the initial earth with background.
                ws = gs_Resource; ws.append(L"background.png");
                wcscpy_s(g_mt[1].FullName, (WCHAR*) ws.c_str());
                ZI_UpdateNamedGLTextureFromFileEx(g_mt[1].FullName, g_mt[1].Texture, g_mt[1].Square);
                // Update the GDImage g_mt[6].Texture, to replace stargate by the flare.
                ws = gs_Resource; ws.append(L"flare0.png");
                wcscpy_s(g_mt[6].FullName, (WCHAR*) ws.c_str());
                ZI_UpdateNamedGLTextureFromFileEx(g_mt[6].FullName, g_mt[6].Texture, g_mt[6].Square);
            }

            C = 1.0f - ((TUNNEL_END - ElapsedTime) / (float) 500); if (C < 0) { C = 1.0f; }
            glColor3f(C, C, C);
            glRotatef(Angle / 2.0f, 0.0f, 0.0f, 1.0f);
            glBindTexture(GL_TEXTURE_2D, g_mt[3].Texture); // StarBurstTex
            glBegin(GL_QUADS);
                glTexCoord2f(0.0f, 0.0f); glVertex3f(-4.5f,-4.5f, 0.0f);
                glTexCoord2f(1.0f, 0.0f); glVertex3f( 4.5f,-4.5f, 0.0f);
                glTexCoord2f(1.0f, 1.0f); glVertex3f( 4.5f, 4.5f, 0.0f);
                glTexCoord2f(0.0f, 1.0f); glVertex3f(-4.5f, 4.5f, 0.0f);
            glEnd();
            glRotatef(-Angle, 0.0f, 0.0f, 1.0f);
            glBegin(GL_QUADS);
                glTexCoord2f(0.0f, 0.0f); glVertex3f(-4.5f,-4.5f, 0.0f);
                glTexCoord2f(1.0f, 0.0f); glVertex3f( 4.5f,-4.5f, 0.0f);
                glTexCoord2f(1.0f, 1.0f); glVertex3f( 4.5f, 4.5f, 0.0f);
                glTexCoord2f(0.0f, 1.0f); glVertex3f(-4.5f, 4.5f, 0.0f);
            glEnd();
        }

        // Draw star particles
        if (DemoTime > 5000) {
            A1 = -2 * cos(Angle / 29.0f) - sin(Angle / 13.0f);
            A2 = -2 * sin(Angle / 33.0f) - cos(Angle / 17.0f);

            if ((DemoTime > 11000) && (DemoTime < 26000)) { J = 40; } else { J = 1; }

            glColor3f(1.0f, 0.8f, 0.0f);
            for (I = 1; I <= J; I++) {
                // Set up ga_Particle coordinates based on tunnel coords
                ParticleZ = (DemoTime - 7000 - J * 150) / (float) (200 - (DemoTime - 4000) / 140.0f) - ga_Particle[I].Z * 3;
                ParticleZ += 0.003f;
                if (ParticleZ > 24) {
                    ga_Particle[I].Z = (DemoTime - 7000 - J * 150) / (float) (200 - (DemoTime - 4000) / 140.0f - 24) / 3;
                }

                A4 = Angle + 2.0f * ParticleZ;
                ParticleX =  2.0f * cos(A4 / 29.0f) + sin(A4 / 13.0f) + A1;
                ParticleY =  2.0f * sin(A4 / 33.0f) + cos(A4 / 17.0f) + A2;
                R = 1.0f / (float)(6.0f + ParticleZ / 2.0f);

                if (I % 2 == 0) { nTex = 2; } else { nTex = 7; }
                glBindTexture(GL_TEXTURE_2D, g_mt[nTex].Texture); //  ParticleTex

                glPushMatrix();
                    glTranslatef(ParticleX + ga_Particle[I].X, ParticleY + ga_Particle[I].Y, -ParticleZ);
                    glScalef(R, R, R);
                    glBegin(GL_QUADS);
                        glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f, 0.0f);
                        glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f, 0.0f);
                        glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, 0.0f);
                        glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, 0.0f);
                    glEnd();
                glPopMatrix();
            }
        }
    }

    if (ShowMonolith) {
        // Shall we ZoomOut to show the monolith the first time.
        LastTime = GetTickCount();
        if (TimeZoomOut > LastTime) {
            ZoomIs = ZI_GetGLzoom(gh_GLwnd);
            SetZoom(((ZoomIs * 100) - (TimeZoomOut - LastTime)) / 100);
        }

        glPushMatrix();
            glTranslatef(-1.8f, -0.20f, -1.80f);
            glRotatef(MonolithAngle, 0.25f, 1.0f, 1.0f);
            DrawMonolith(nValue, Pulse, MonolithAngle, 1);
        glPopMatrix();

        glPushMatrix();
            glTranslatef(1.8f, -0.20f, -1.80f);
            glRotatef(MonolithAngle, 1.0f, 1.0f, 0.25f);
            DrawMonolith(nValue, Pulse, MonolithAngle + 90.0f, 2);
        glPopMatrix();

        glPushMatrix();
            glRotatef(MonolithAngle, 1.0f, 0.25f, 1.0f);
            DrawMonolith(nValue, Pulse, MonolithAngle + 180.0f, 3);
        glPopMatrix();

        MonolithAngle += 0.1f + Pulse; if (MonolithAngle > 360) { MonolithAngle -= 360; }

        if (TimeZoomOut > LastTime) {
            SetZoom(ZoomIs);
        }
    }
    // Update the display
    ZI_UpdateGLWindow(gh_GLwnd);
}

void PaintMain(IN HWND hWin) {
    PAINTSTRUCT ps = {0};
    BeginPaint(hWin, &ps);
    EndPaint(hWin, &ps);
    gl_DrawScene();
}

LRESULT CALLBACK WndProc(IN HWND hWin, IN UINT uMsg, IN WPARAM wParam, IN LPARAM lParam) {

    MINMAXINFO* pMM;
    long wmId, wmEvent;
    wstring ws;

    switch (uMsg) {

    case WM_GETMINMAXINFO:
         pMM = (MINMAXINFO*) lParam;
         pMM->ptMinTrackSize.x = MinTrackSizeW(0);
         pMM->ptMinTrackSize.y = MinTrackSizeH(0);
         break;

    case WM_TIMER:
         gl_DrawScene();
         break;

    case WM_COMMAND:
         wmId    = LOINT(wParam);
         wmEvent = HIWORD(wParam);

         switch (wmId) {

         case IDC_RESET:
              gl_Obj.xoff = -0.0f;  // Initial x location.
              gl_Obj.yoff = -0.0f;  // Initial y location.
              gl_Obj.zoff = -3.0f;  // Initial zoom factor.
              gl_Obj.xrot = 5.0f;
              gl_Obj.yrot = 0.0f;
              gl_Obj.radius = 0.0f;
              // Restore Zoom value.
              SendMessage(GetDlgItem(hWin, IDC_ZOOM), TBM_SETPOS, 1, ZOOM_DEFAULT);
              SetZoom(101 - (long) SendMessage(GetDlgItem(hWin, IDC_ZOOM), TBM_GETPOS, 0, 0));
              gl_DrawScene();
              break;
         }
         return 0;

    case WM_HSCROLL:
         if (GetDlgCtrlID((HWND) lParam) == IDC_ZOOM) {
             // Do not use nPosition, because it could be NULL.
             SetZoom(101 - (long) SendMessage((HWND) lParam, TBM_GETPOS, 0, 0));
             gl_DrawScene();
         }
         break;

    case WM_MOUSEWHEEL:
         if (GetFocus() != gh_GLwnd) { SetFocus(gh_GLwnd); }
         break;

    case WM_SIZE:
         ZI_ResizeGLWindow(gh_GLwnd);
         gl_DrawScene();
         break;

    case WM_CLOSE:
         BassCloseChannel();
         break;

    case WM_PAINT:
         PaintMain(hWin);
         return 0;

    case WM_DESTROY:
         PostQuitMessage(0);
         return 0;
    }
    return DefWindowProc(hWin, uMsg, wParam, lParam);
}

// Subclassing callback for the OpenGL control
LRESULT CALLBACK glWndProc(IN HWND hWnd, IN UINT uMsg, IN WPARAM wParam, IN LPARAM lParam) {

    RECT rc = {0};
    static long LeftMousing, RightMousing, wasLX, wasLY, wasRX, wasRY;

    long x = 0, y = 0, dx = 0, dy = 0;

    switch (uMsg) {

    case WM_PAINT:
         gl_DrawScene();
         break;

    case WM_LBUTTONDOWN:
         if (LeftMousing == FALSE) {
             x = LOINT(lParam); y = HIINT(lParam);
             gl_Obj.xcpy = gl_Obj.xrot;
             gl_Obj.ycpy = gl_Obj.yrot ;

             gl_Obj.xdown = x;
             gl_Obj.ydown = y;
             LeftMousing = TRUE;
         }
         if (GetFocus() != hWnd) { SetFocus(hWnd); }
         break;

    case WM_LBUTTONUP:
         LeftMousing = FALSE;
         break;

    case WM_RBUTTONDOWN:
         if (RightMousing == FALSE) {
             x = LOINT(lParam); y = HIINT(lParam);
             gl_Obj.xcpy = gl_Obj.xoff;
             gl_Obj.ycpy = gl_Obj.yoff;

             gl_Obj.xdown = x;
             gl_Obj.ydown = y;
             RightMousing = TRUE;
         }
         if (GetFocus() != hWnd) { SetFocus(hWnd); }
         break;

    case WM_RBUTTONUP:
         RightMousing = FALSE;
         break;

    case WM_MOUSEMOVE:
         x = LOINT(lParam); y = HIINT(lParam);

         if (ZI_IsLButtonDown() == 0) {
             LeftMousing = FALSE; }
         else {
             if ((wasLX != x) || (wasLY != y)) {
                 if (LeftMousing) {
                    dx = x - gl_Obj.xdown; gl_Obj.yrot = gl_Obj.ycpy + dx / 2.0f;
                    dy = y - gl_Obj.ydown; gl_Obj.xrot = gl_Obj.xcpy + dy / 2.0f;
                 }
                 gl_DrawScene() ;
             }
             wasLX = x; wasLY = y;
         }
        
         if (ZI_IsRButtonDown() == 0) {
             RightMousing = FALSE; }
         else {
             if ((wasLX != x) || (wasLY != y)) {
                 if (RightMousing) {
                     GetClientRect(gh_GLwnd, &rc);
                     dx = x - gl_Obj.xdown; gl_Obj.xoff = gl_Obj.xcpy - (-45 * dx) / (12.0f * rc.right);  // Use 12.0 instead of 2.0 to reduce sensitivity
                     dy = y - gl_Obj.ydown; gl_Obj.yoff = gl_Obj.ycpy + (-45 * dy) / (12.0f * rc.bottom); // Use 12.0 instead of 2.0 to reduce sensitivity
                 }
                 gl_DrawScene();
             }
             wasRX = x; wasRY = y;
         }
         break;
    }
    return CallWindowProc(gh_GLproc, hWnd, uMsg, wParam, lParam);
}

HWND zStaticCenter(IN wstring sLabel, IN long x, IN long y, IN long w, IN long h, IN HWND hParent, IN long nID) {
    HWND hCtl = CreateWindowEx(0, L"STATIC", sLabel.c_str(), WS_CHILD | WS_BORDER | WS_VISIBLE | SS_CENTER, x, y, w, h, hParent, (HMENU) nID, zInstance(), NULL);
    return hCtl;
}

//// The animation thread procedure.
//// you can use the code below, instead of the IDC_TIMER when running on a Multicore I7.,
//void Animate (IN LPVOID nDelay) {
//    for (;;) {
//        ZI_UpdateWindow(gh_GLwnd, TRUE);
//        Sleep((long) nDelay);
//    }
//}

//// Create the animation thread.
//// you can use the code below, instead of the IDC_TIMER when running on a Multicore I7.,
//long StartAnimation (IN long Delay) {
//    long nRet = LB_ERR;
//    DWORD dwThreadId = 0;
//    HANDLE hThread = CreateThread(NULL,                                  // default security attributes
//                                  0,                                     // use default stack size  
//                                  (LPTHREAD_START_ROUTINE ) Animate,     // thread function name
//                                  (LPVOID) Delay,                        // argument to thread function 
//                                  0,                                     // use default creation flags 
//                                  &dwThreadId);                          // returns the thread identifier
//    if (hThread) { nRet = 0; Sleep(100); }
//    CloseHandle(hThread);
//    return nRet;
//}

int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow) {

    UNREFERENCED_PARAMETER(hPrevInstance);
    UNREFERENCED_PARAMETER(lpCmdLine);

    MSG msg;
    long nRet = 0;
    WNDCLASSEX wcx = {0};
    WCHAR szWindowClass[] = L"ZSTARGATE";

    RECT rc;
    long x, y, w, h, IsInitialized;
    DWORD dwStyle, dwExStyle;
    HWND gh_Main, hFound, hCtrl;

    ZGLFONT UseFont = {0};

    // Create a mutex to avoid running twice the same application.
    HANDLE hMutex = CreateMutex(NULL, 0, szWindowClass);
    if (hMutex) {
       if (GetLastError() == ERROR_ALREADY_EXISTS) {
          for(;;){
              hFound = FindWindow(szWindowClass, NULL); if (hFound) { break; }
              while (PeekMessage(&msg, NULL, NULL, NULL, PM_REMOVE)) { }
          }
          if (IsIconic(hFound)) { ShowWindow(hFound, SW_RESTORE); }
          SetForegroundWindow(hFound);
          return 0;
       }
    }

    // Register our main window class
    wcx.cbSize = sizeof(wcx);
    IsInitialized = GetClassInfoEx(hInstance, szWindowClass, &wcx);
    if (!IsInitialized) {
       wcx.style         = 0; // CS_HREDRAW | CS_VREDRAW;
       wcx.lpfnWndProc   = WndProc;
       wcx.cbClsExtra    = 0;
       wcx.cbWndExtra    = 0;
       wcx.hInstance     = hInstance;
       wcx.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_APPLICATION));
       wcx.hCursor       = LoadCursor(NULL, IDC_ARROW);
       wcx.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
       wcx.lpszMenuName  = NULL;
       wcx.lpszClassName = szWindowClass;
       wcx.hIconSm       = wcx.hIcon;
       if (RegisterClassEx(&wcx)) { IsInitialized = -1; }
    }
    if (IsInitialized) {

       // Load the GDImage.dll
       if (RegisterGDImageClass() == 0) { // If it fails to register then return ERROR = 99
           return 99; }
       else {
          ZI_LoadDLL(L"");
       }

       // Window Extended Style
       dwExStyle = WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;
       // Windows Style
       dwStyle = WS_OVERLAPPEDWINDOW | WS_CLIPSIBLINGS | WS_CLIPCHILDREN;
       SetRect(&rc, 0, 0, ClientW, ClientH);
       AdjustWindowRectEx(&rc, dwStyle, FALSE, dwExStyle);    // Adjust Window To True Requested Size

       x = max((GetSystemMetrics(SM_CXSCREEN) - rc.right - rc.left) / 2, 0);
       y = max((GetSystemMetrics(SM_CYSCREEN) - rc.bottom - rc.top) / 2, 0);
       MinTrackSizeW(rc.right - rc.left);
       MinTrackSizeH(rc.bottom - rc.top);

       // Create the MAIN window
       wstring sCaption = L"StarGate ";
       if (sizeof(LONG_PTR) == 8) { 
           sCaption += L"64-bit"; }
       else { 
           sCaption += L"32-bit";
       }

       gh_Main = CreateWindowEx(dwExStyle,                // Extended Style For The Window
                             szWindowClass,               // Class Name
                             (WCHAR*) sCaption.c_str(),   // Window Title
                             dwStyle,                     // Defined Window Style
                             x, y,                        // Window Position
                             MinTrackSizeW(0),            // Calculate Window Width 
                             MinTrackSizeH(0),            // Calculate Window Height
                             NULL,                        // No Parent Window
                             NULL,                        // No Menu
                             hInstance,                   // Instance
                             NULL);                       // Dont Pass Anything To WM_CREATE

       if (gh_Main) {

           // Setup our resource folder.
           gs_Resource = EXEpath(); gs_Resource.append(L"Resource\\");

           // Create a WGL GDImage control supporting OpenGL extensions.
           dwExStyle = 0; dwStyle = WS_CHILD | WS_VISIBLE;
           gh_GLwnd = WGL_CreateWindow(dwExStyle, dwStyle, 10, 10, ClientW - 156, ClientH - 20, gh_Main, (HMENU) IDC_GLCTRL);

           if (gh_GLwnd) {
               // Subclass the OpenGL control, to monitor the mouse/user interaction.
               gh_GLproc = (WNDPROC) SetWindowLongPtr(gh_GLwnd, GWLP_WNDPROC, (LONG_PTR) glWndProc);

               // Init OpenGL;
               gl_Initialize();

               // Start skinning the MAIN window;
               wstring ws = EXEpath(); ws += L"Podcast.sks";
               if (skInitEngine ((WCHAR*) ws.c_str(), L"")) {
                   skSkinWindow(gh_Main, L"Dock|Undock|Minimize|Maximize|Restore|Close");

                   // Anchor the GDImage WGL control (to let it be resizable).
                   skSetAnchorCtrl(gh_GLwnd, ANCHOR_HEIGHT_WIDTH);

                   // Add a trackbar to perform the zooming.
                   hCtrl = CreateWindowEx(0, L"MSCTLS_TRACKBAR32", NULL,
                                          WS_CHILD | WS_VISIBLE | WS_TABSTOP | TBS_HORZ | TBS_BOTTOM | TBS_AUTOTICKS,
                                          ClientW - 128, ClientH - 75, 120, 16, 
                                          gh_Main, (HMENU) IDC_ZOOM,
                                          hInstance, NULL);
                   skSetAnchorCtrl(hCtrl, ANCHOR_BOTTOM_RIGHT);
                   // Setup the trackbar parameters.
                   SendMessage(hCtrl, TBM_SETPAGESIZE, 0, 1);
                   SendMessage(hCtrl, TBM_SETLINESIZE, 0, 1);
                   SendMessage(hCtrl, TBM_SETTICFREQ, 0, 1);
                   SendMessage(hCtrl, TBM_SETRANGE, 1, MAKELONG(30, 90));  // Set the zooming range.
                   SendMessage(hCtrl, TBM_SETPOS, 1, ZOOM_DEFAULT);
                   skSkinChildCtrl(hCtrl, 0); // Skin it on the fly
                   skCreateToolTip(hCtrl, L"zooming"); // Add tooltip (tooltip must be first enabled with #pragma)

                   // Add a skinned border around the GDImage control.
                   // The color of the border is defined in the skin.sks theme file.
                   GetWindowRect(gh_GLwnd, &rc);
                   POINT p = {0};
                   p.x = rc.left; p.y = rc.top;
                   ScreenToClient(gh_Main, &p);
                   skBorder(gh_GLwnd, p.x - 1, p.y - 1, rc.right - rc.left + 2, rc.bottom - rc.top + 2, 0, 1);

                   // Add a WinLIFT clock control.
                   ws = gs_Resource; ws.append(L"Clock.png");
                   hCtrl = skClockCtrl(gh_Main, (WCHAR*) ws.c_str(), p.x + rc.right - rc.left + 31, p.y, 0, 0, IDC_CLOCK, 0x7FCB0000, 0x7F8F8F8F, 0);
                   skSetAnchorCtrl(hCtrl, ANCHOR_RIGHT);

                   x = ClientW - 132; y = 10 + (22 + 5) * 5 + 5; w = 127; h = 192;
                   // Add a WinLIFT static image background.
                   ws = gs_Resource; ws.append(L"assistant.png");
                   hCtrl = skStaticImage(gh_Main, (WCHAR*) ws.c_str(), x, y, w, h, IDC_STATIC_IMG);
                   skSetAnchorCtrl(hCtrl, ANCHOR_BOTTOM_RIGHT);
                   // Create our helper static control.
                   hCtrl = zStaticCenter(L"\n\rMouse buttons\n\r\n\rLeft: rotation, and view angle.\n\r\n\rRight:\n\rnew X,Y location.", 
                                         x, y, w, h, gh_Main, IDC_STATIC);
                   skSkinChildCtrl(hCtrl, 0); // Skin it on the fly
                   // Use a private font, always available what ever the computer used (no need to register it first).
                   ws = gs_Resource; ws.append(L"spaceage.ttf");
                   skSetLabelFont(hCtrl, (WCHAR*) ws.c_str(), 15, skARGB(255, 3,88,188), FontStyleRegular);//FontStyleBold); // Use this font
                   skSetAnchorCtrl(hCtrl, ANCHOR_BOTTOM_RIGHT); // Anchor this control

                   // Create the Reset push button.
                   hCtrl = CreateWindowEx(0, L"BUTTON", L"Reset", WS_CHILD | WS_VISIBLE | WS_TABSTOP, 
                                          ClientW - 132, ClientH - (145+40), 127, 30, gh_Main, (HMENU) IDC_RESET, hInstance, NULL);
                   skSkinChildCtrl(hCtrl, 0); // Skin it on the fly
                   // Use same font for button than for the helper message.
                   skSetLabelFont(hCtrl, (WCHAR*) ws.c_str(), 22, skARGB(255, 3,88,188), FontStyleRegular);
                   skSetAnchorCtrl(hCtrl, ANCHOR_BOTTOM_RIGHT); // Anchor this control

                   // Start playing audio using Bass.dll.
                   ws = gs_Resource; ws.append(L"intro.ogg");
                   wcscpy_s(ta.AudioFile, (WCHAR*) ws.c_str());
                   BassChannelPlay(gh_Main);

                   // Fire the animation thread 
                   // you can use this, instead of the IDC_TIMER when running on Multicore I7,
                   // else better to use a TIMER.
//                   StartAnimation(TIMER_DELAY);

               }

               // Show the main window
               ShowWindow(gh_Main, nCmdShow);
               SetForegroundWindow(gh_Main); // Slightly Higher Priority

               // Main message pump.
               SetTimer(gh_Main, IDC_TIMER, 0, 0); // 66 FPS
               while (GetMessage(&msg, NULL, 0, 0)) {
                     TranslateMessage(&msg);
                     DispatchMessage(&msg);
               }
               KillTimer(gh_Main, IDC_TIMER);
               nRet = (long) msg.wParam;

               // Cleanup texture from memory
               gl_DestroyTexture();

            }
        }
    }

    if (hMutex) { CloseHandle(hMutex); }
    return nRet;
}
