#include "stdafx.h"
#include <algorithm> 
#include <string>

using namespace std;

static wchar_t  *$NULL              = L"";
const wchar_t   *$ANTI              = L"\\";
const wchar_t   *$DOT               = L".";

#define strSize(s) ( sizeof(s) / sizeof(s[0]) ) 
#define LOINT(a) ((SHORT)(a))
#define HIINT(a) ((SHORT)(((DWORD)(a) >> 16) & 0xFFFF))
#define long_proc typedef long (__stdcall *zProc)

long zTrace (IN wstring sPtr) {
    long nRet = 0;
    static HMODULE hDll;
    if (hDll == 0) { 
        if (sizeof(LONG_PTR) == 8) {
            hDll = LoadLibrary(L"zTrace64"); }
        else {
            hDll = LoadLibrary(L"zTrace32");
        }
    }
    if (hDll) {
        long_proc (WCHAR*);
        zProc hProc = (zProc) GetProcAddress(hDll, "zTrace");
        if (hProc) { nRet = hProc((WCHAR*) sPtr.c_str()); }
    }
    return nRet;
}

long INSTR(IN long nIndex, IN wstring sMain, IN wstring sSearch) {
    long nRet = -1; // Not found
    long nLength = (long) (sMain.length());
    if (nLength && (sSearch.length())) {
        if (nIndex < 0) {
            nRet = (long) (sMain.rfind(sSearch, nLength + nIndex + 1)); }
        else {
            nRet = (long) (sMain.find(sSearch, nIndex));
        }
    }
    return nRet + 1;
}

wstring LEFT$(IN wstring sBuf, IN long nLeft) { // dllexport
    wstring sResult = $NULL;
    LONG_PTR nLength = max(min((long)sBuf.length(), nLeft), 0);
    if (nLength) {
        sResult = sBuf.substr(0, nLength);
    }
    return sResult;
}

wstring MID$(IN wstring sBuf, IN long nStart, IN long nMid = 0) { // dllexport
    wstring sResult = $NULL;
    long nLength = (long) sBuf.length();
    if (nMid == 0) { nMid = nLength - nStart + 1; }
    if (nLength) { sResult = sBuf.substr(nStart - 1, nMid); }
    return sResult;
}

wstring RTRIM$(IN wstring sBuf, IN wstring sChar) { // dllexport
    wstring sResult = sBuf;
    LONG_PTR nLength = sBuf.length();
    if (nLength && (sChar.length())) {
        //sChar = sChar.substr(0, 1);
        while (nLength > 0) {
            // if (*sBuf.substr(nLength - 1, 1).c_str() == *sChar.c_str()) {
            // This is the sChar ANY search version
            if (std::wstring::npos != sChar.find(sBuf.substr(nLength - 1, 1))) {
                --nLength; }
            else {
                break;
            }
        }
        sResult = sBuf.substr(0, nLength);
    }
    return sResult;
}

void zDskPath (OUT wstring &sDsk, OUT wstring &sPath) {
    WCHAR buf[MAX_PATH];
    if (GetCurrentDirectory(MAX_PATH, buf)) {
        sDsk = LEFT$((wstring) buf, 2);
        sPath = RTRIM$(MID$((wstring) buf, 3), $ANTI);
        sPath += $ANTI;
    }
}

void SplitFileName (IN WCHAR* FullName, OUT WCHAR* PathName, OUT WCHAR* FilName) {
    wstring sDsk = $NULL, sThisPath = $NULL;
    long So = 0, nLength = 0;
    wstring sFullName = (WCHAR*) FullName;
    wstring sPathName = $NULL;
    wstring sFilName = $NULL;
    // if no path is specified { the current directory is being used.
    sPathName = $NULL; sFilName = $NULL;
    nLength = (long) (sFullName.length());
    if (nLength) {
       zDskPath(sDsk, sThisPath); sFilName = sFullName;
       So = INSTR(-1, sFullName, $ANTI);
       if (So) {
           sPathName = LEFT$(sFullName, So); }
       else {
          So = INSTR(0, sFullName, L":");
       }
       if ((sPathName.c_str() == sDsk.c_str()) || (sPathName.length() == 0)) {
          sPathName = sDsk; sPathName += sThisPath;
       }
       if (So) { sFilName = MID$(sFullName, So + 1, nLength - So); }
    }
    MoveMemory(&PathName[0], (WCHAR*) sPathName.c_str(), sPathName.length() * sizeof(WCHAR));
    MoveMemory(&FilName[0], (WCHAR*) sFilName.c_str(), sFilName.length() * sizeof(WCHAR));
}

wstring EXEpath() {
    wstring sResult;
    WCHAR exepath[MAX_PATH] = {0};
    if (GetModuleFileName(0, exepath, sizeof(exepath))) {
       sResult = exepath;
       sResult = sResult.substr( 0, sResult.rfind(L"\\"));
       sResult += L"\\";
    }
    return sResult;
}

wstring EXTRACT$(IN long nIndex, IN wstring sMain, IN wstring sSearch) { // dllexport
    wstring sResult = sMain;
    long nLength = (long) sMain.length();
    long nRet = -1; // Not found
    if (nLength && (sSearch.length())) {
        if (nIndex < 0) {
            nRet = (long) sMain.rfind(sSearch, nLength + nIndex + 1); }
        else {
            nRet = (long) sMain.find(sSearch, nIndex);
        }
    }
    if (nRet > -1) { sResult = LEFT$(sMain, nRet); }
    return sResult;
}

wstring LCASE$(IN wstring sBuf) {
    std::transform(sBuf.begin(), sBuf.end(), sBuf.begin(), ::tolower);
    return sBuf;
}

wstring STRL$(IN long N) {
    WCHAR longstr[33] = {0};
    _ltow_s(N, longstr, 10);
    return (WCHAR*) longstr;
}

wstring STRPTR$(IN LONG_PTR N) {
    WCHAR longstr[33] = {0};
    _i64tow_s(N, longstr, 33, 10);
    return (WCHAR*) longstr;
}

wstring STRF$(IN float N) {
    WCHAR ws[33] = {0};
    swprintf(ws, strSize(ws), L"%f", N);
    return (WCHAR*) ws;
}
